ALTER FUNCTION [dbo].[GRAND_LIVRE]
(
    @EXERCICE_IDT int,
    @CPTE_DEB VARCHAR(15),
    @CPTE_FIN VARCHAR(15),
    @DATE_DEB DATETIME,
    @DATE_FIN DATETIME,
    @SLD_ANT SMALLINT,
    @SLD_POST SMALLINT,
    @CPTVIDE SMALLINT
)
RETURNS @TEMPTBL TABLE 
(
    ECR_ID INT,
    JOURNAL VARCHAR(3),
    DATE_ECR DATETIME,
    CPTE VARCHAR(15),
    LIBELLE VARCHAR(80),
    INTITULE VARCHAR(120),
    TIERS_ID VARCHAR(15),
    NO_PIECE VARCHAR(25),
    CCPTE VARCHAR(15),
    DEBIT NUMERIC(17,2),
    CREDIT NUMERIC(17,2),
    DEBIT_ME NUMERIC(17,2),
    CREDIT_ME NUMERIC(17,2),
    TVA_ID VARCHAR(2),
    MONNAIE VARCHAR(3),
    MONNAIE_COMPTE varchar(3)
)
AS
BEGIN
DECLARE 
    @SOLDE_INI_ME NUMERIC(19,4) = 0,
    @SOLDE_INI NUMERIC(19,4) = 0,
    @COUNT_ECR INT = 0,
    @DEFAULT_MONNAIE varchar(3) = null,
    @AFFICHE_SLD_INI SMALLINT = 0,
    @DATE_DEBUT_EX DATETIME = null,

    @ECR_ID INT = null,
    @JOURNAL VARCHAR(5) = null,
    @DATE_ECR DATETIME = null,
    @CPTE VARCHAR(15) = null,
    @LIBELLE VARCHAR(80) = null,
    @INTITULE VARCHAR(120) = null,
    @TIERS_ID VARCHAR(15) = null,
    @NO_PIECE VARCHAR(25) = null,
    @CCPTE VARCHAR(15) = null,
    @DEBIT NUMERIC(19,4) = 0,
    @CREDIT NUMERIC(19,4) = 0,
    @DEBIT_ME NUMERIC(19,4) = 0,
    @CREDIT_ME NUMERIC(19,4) = 0,
    @TVA_ID VARCHAR(2) = null,
    @MONNAIE VARCHAR(3) = null,
    @MONNAIE_COMPTE VARCHAR(3) = null

    --monnaie par d�faut de la soci�t�
    SELECT @DEFAULT_MONNAIE = SUBSTRING(val, 1, 3)
    FROM SYSVALSOC
    WHERE idval = 'CURRENCY'
    AND EXISTS (
        SELECT *
        FROM EXERCICE
        WHERE MANDAT_IDT = SYSVALSOC.MANDAT_IDT
        AND EXERCICE_IDT = @EXERCICE_IDT
    )

    IF ((@DEFAULT_MONNAIE is null) or (LTRIM(RTRIM(@DEFAULT_MONNAIE)) = '')) BEGIN
        SET @DEFAULT_MONNAIE = 'CHF'
    END
    
    --si je suis dans la monnaie locale, ne pas afficher de si en monnaie etrangere
    if (@MONNAIE_COMPTE = @DEFAULT_MONNAIE) begin
        SET @SOLDE_INI_ME = 0
    end
    
    --date de debut de l'exercice (afficher ou non le solde initial)
    SELECT @DATE_DEBUT_EX = DATE_DEBUT
    FROM EXERCICE
    WHERE EXERCICE_IDT = @EXERCICE_IDT


    -- ##### PARCOURS DES COMPTES ##### 
    DECLARE CURSOR1 CURSOR FOR
    SELECT SOLDE_INITIAL, SOLDE_INITIAL_ME, CPTE_ID, INTITULE, CODE_MONNAIE
    FROM comptes
    WHERE CPTE_ID BETWEEN @CPTE_DEB AND @CPTE_FIN
    AND EXERCICE_IDT = @EXERCICE_IDT
    AND coalesce(titre, 0) = 0
    ORDER BY CPTE_ID
    
    OPEN CURSOR1
    FETCH CURSOR1 INTO @SOLDE_INI, @SOLDE_INI_ME, @CPTE, @INTITULE, @MONNAIE_COMPTE
    
    WHILE @@FETCH_STATUS = 0 BEGIN
        SET @DEBIT = 0
        SET @CREDIT = 0
        SET @TVA_ID = null
        SET @DATE_ECR = null
        SET @ECR_ID = null
        SET @DATE_ECR = null
        SET @JOURNAL = null
        
        --monnaie par d�faut de la soci�t�
        IF (coalesce(@MONNAIE_COMPTE, '') = '') BEGIN
            SET @MONNAIE_COMPTE = @DEFAULT_MONNAIE
        END        
        
        -- ##### SOLDE INITIAL #####
        --dois-je afficher le sode initial ?
        SET @AFFICHE_SLD_INI = 0;
        if (@date_deb <= @DATE_DEBUT_EX) begin
          SET @AFFICHE_SLD_INI = 1;
        end else begin
          SET @AFFICHE_SLD_INI = @sld_ant;
        end            
        
        IF (@AFFICHE_SLD_INI = 1) BEGIN
            IF (@SOLDE_INI > 0)  BEGIN
              INSERT INTO @TEMPTBL SELECT @ECR_ID, @JOURNAL, @DATE_ECR, @CPTE, 'SOLDE INITIAL', @INTITULE, @TIERS_ID, null, null, @SOLDE_INI, @CREDIT, @SOLDE_INI_ME, @CREDIT_ME, null, @MONNAIE_COMPTE, @MONNAIE_COMPTE
            END ELSE IF (@solde_ini < 0) BEGIN
              INSERT INTO @TEMPTBL SELECT @ECR_ID, @JOURNAL, @DATE_ECR, @CPTE, 'SOLDE INITIAL', @INTITULE, @TIERS_ID, null, null, @DEBIT, (@SOLDE_INI * -1), @DEBIT_ME, (@SOLDE_INI_ME * -1), null, @MONNAIE_COMPTE, @MONNAIE_COMPTE
            END
        END

        -- ##### SOLDE ANTERIEUR #####
        IF (@SLD_ANT = 1) BEGIN
            DECLARE CURSORANT CURSOR FOR

                SELECT case coalesce(MONNAIE, '')
                        WHEN '' THEN @DEFAULT_MONNAIE
                        ELSE MONNAIE
                        END,
                       'SOLDE ANTERIEUR', SUM(DEBIT), SUM(CREDIT),
                       SUM(DEBIT_ME), SUM(CREDIT_ME), count(*)
                FROM ecritures
                WHERE EXERCICE_IDT = @EXERCICE_IDT
                AND CPTE = @CPTE
                AND DATE_ECR < @date_deb
                GROUP BY case coalesce(MONNAIE, '')
                        WHEN '' THEN @DEFAULT_MONNAIE
                        ELSE MONNAIE
                        END
                
            OPEN CURSORANT
            FETCH CURSORANT INTO @MONNAIE, @LIBELLE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @COUNT_ECR
            
            WHILE @@FETCH_STATUS = 0 BEGIN    
                --si je suis dans la monnaie locale, ne pas afficher de monnaie etrangere
                if (@MONNAIE_COMPTE = @DEFAULT_MONNAIE) begin
                    SET @DEBIT_ME = 0
                    SET @CREDIT_ME = 0
                end
                        
                IF (@COUNT_ECR > 0) BEGIN
                  INSERT INTO @TEMPTBL SELECT null, null, null, @CPTE, @LIBELLE, @INTITULE, null, null, null, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, null, @MONNAIE, @MONNAIE_COMPTE
                END
                
                FETCH CURSORANT INTO @LIBELLE, @MONNAIE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @COUNT_ECR
            END
            
            CLOSE CURSORANT
            DEALLOCATE CURSORANT            
        END

        -- ##### LISTE DES ECRITURES #####        
        DECLARE CURSOR2 CURSOR FOR
            SELECT ECR_ID, JOURNAL, TIERS_ID, NO_PIECE, DATE_ECR, LIBELLE, CCPTE, DEBIT, CREDIT, DEBIT_ME, CREDIT_ME, TVA_CODE,
               CASE coalesce(MONNAIE, '')
                 WHEN '' THEN @DEFAULT_MONNAIE
                 ELSE MONNAIE
               END
           
            FROM ecritures
            WHERE EXERCICE_IDT = @EXERCICE_IDT
            AND CPTE = @CPTE
            AND DATE_ECR BETWEEN @Date_deb AND @date_fin
            ORDER BY DATE_ECR, ECR_ID

        OPEN CURSOR2
        FETCH CURSOR2 INTO @ECR_ID, @JOURNAL, @TIERS_ID, @NO_PIECE, @DATE_ECR, @LIBELLE, @CCPTE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @TVA_ID, @MONNAIE

        WHILE @@FETCH_STATUS = 0 BEGIN
            IF ((@CCPTE IS NULL) OR (@CCPTE = '')) BEGIN
                SET @CCPTE = 's/div';
            END
            
            --si je suis dans la monnaie locale, ne pas afficher de monnaie etrangere
            if (@MONNAIE_COMPTE = @DEFAULT_MONNAIE) begin
                SET @DEBIT_ME = 0
                SET @CREDIT_ME = 0
            end                    

            SET @COUNT_ECR = @COUNT_ECR + 1;
            INSERT INTO @TEMPTBL SELECT @ECR_ID, @JOURNAL, @DATE_ECR, @CPTE, @LIBELLE, @INTITULE, @TIERS_ID, @NO_PIECE, @CCPTE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @TVA_ID, @MONNAIE, @MONNAIE_COMPTE
            FETCH CURSOR2 INTO @ECR_ID, @JOURNAL, @TIERS_ID, @NO_PIECE, @DATE_ECR, @LIBELLE, @CCPTE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @TVA_ID, @MONNAIE
        END
        
        CLOSE CURSOR2
        DEALLOCATE CURSOR2
        
        -- ##### si compteur est � z�ro, aucune �criture recens�e #####
        IF ( (@COUNT_ECR = 0) AND ((@AFFICHE_SLD_INI = 1) and (@SOLDE_INI = 0)) AND (@CPTVIDE = 1) ) BEGIN
            SELECT @CPTE = CPTE_ID, @LIBELLE = 'AUCUNE ECRITURE RECENSEE', @JOURNAL = null, @DEBIT = null, @CREDIT = null, @TVA_ID = null, @NO_PIECE = null, @CCPTE = null, @ECR_ID = null, @DATE_ECR = null, @DEBIT_ME = null, @CREDIT_ME = null
            FROM COMPTES
            WHERE EXERCICE_IDT = @EXERCICE_IDT
            AND CPTE_ID = @CPTE

            INSERT INTO @TEMPTBL SELECT @ECR_ID, @JOURNAL, @DATE_ECR, @CPTE, @LIBELLE, @INTITULE, @TIERS_ID, @NO_PIECE, @CCPTE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @TVA_ID, @MONNAIE_COMPTE, @MONNAIE_COMPTE
        END
        
        -- ##### SOLDE POSTERIEUR #####
        IF (@SLD_ANT = 1) BEGIN
            DECLARE CURSORPOST CURSOR FOR
                SELECT    CASE coalesce(MONNAIE, '')
                          WHEN '' THEN @DEFAULT_MONNAIE
                          ELSE MONNAIE
                        END,
                'SOLDE POSTERIEUR', SUM(DEBIT), SUM(CREDIT),
                       SUM(DEBIT_ME), SUM(CREDIT_ME), count(*)
                FROM ecritures
                WHERE EXERCICE_IDT = @EXERCICE_IDT
                AND CPTE = @CPTE
                AND DATE_ECR > @date_deb
                GROUP BY CASE coalesce(MONNAIE, '')
                          WHEN '' THEN @DEFAULT_MONNAIE
                          ELSE MONNAIE
                         END
                
            OPEN CURSORPOST
            FETCH CURSORPOST INTO @MONNAIE, @LIBELLE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @COUNT_ECR
            
            WHILE @@FETCH_STATUS = 0 BEGIN                
                --si je suis dans la monnaie locale, ne pas afficher de monnaie etrangere
                if (@MONNAIE_COMPTE = @DEFAULT_MONNAIE) begin
                    SET @DEBIT_ME = 0
                    SET @CREDIT_ME = 0
                end
                            
                IF (@COUNT_ECR > 0) BEGIN
                  INSERT INTO @TEMPTBL SELECT null, null, null, @CPTE, @LIBELLE, @INTITULE, null, null, null, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, null, @MONNAIE, @MONNAIE_COMPTE
                END
                
                FETCH CURSORPOST INTO @LIBELLE, @MONNAIE, @DEBIT, @CREDIT, @DEBIT_ME, @CREDIT_ME, @COUNT_ECR
            END
            
            CLOSE CURSORPOST
            DEALLOCATE CURSORPOST            
        END
        
        FETCH CURSOR1 INTO @SOLDE_INI, @SOLDE_INI_ME, @CPTE, @INTITULE, @MONNAIE_COMPTE
    END    

    CLOSE CURSOR1
    DEALLOCATE CURSOR1
    RETURN
END
go


ALTER PROCEDURE [dbo].[SYSGEN] 
    @SEQ_ID VARCHAR(30),
    @EXERCICE_IDT INTEGER,
    @RES INT OUTPUT
AS
BEGIN    
  SET NOCOUNT ON
  SET @RES = 0
  
  DECLARE @sql nvarchar(255), @tst int
  DECLARE @generator_name varchar(39)
  
  if (coalesce(@EXERCICE_IDT, -1) > -1) begin
        SET @generator_name = '__' + @SEQ_ID + '_' + cast(@EXERCICE_IDT as nvarchar(9))
  end else begin
        SET @generator_name = '__' + @SEQ_ID
  end

  SET @sql = N'INSERT INTO ' + @generator_name + N'(dtime) SELECT CURRENT_TIMESTAMP; SELECT @r=SCOPE_IDENTITY();'
  EXEC sp_executesql @sql , N'@r INTEGER OUTPUT', @RES OUTPUT
END
go


ALTER PROCEDURE [dbo].[CALC_GENERATORS]
    @iexercice_idt int
AS
BEGIN
  SET NOCOUNT ON;
  
  DECLARE    
    @exercice_idt int,
    @tbl varchar(25),
    @id_field varchar(25),
    @docalc smallint,
    @sql varchar(255),
    @SEQ VARCHAR(45),
    @CNT INTEGER

  DECLARE CURSOR1 CURSOR FOR
    SELECT SEQ, COALESCE(exercice_idt, -1), COALESCE(TABLE_NAME, ''), COALESCE(ID_FIELD, '')
    FROM SYSSEQUENCE
    ORDER BY SEQ
    
  OPEN CURSOR1
  FETCH CURSOR1 INTO @SEQ, @exercice_idt, @TBL, @ID_FIELD
            
  WHILE @@FETCH_STATUS = 0 BEGIN
    SET @DOCALC = 1;
    
    --calculation seulement pour la soci�t� ou exercice demand�
    IF (@iexercice_idt is null) BEGIN SET @iexercice_idt = -1 END

    IF (@iexercice_idt > -1) BEGIN
        IF (@iexercice_idt <> @exercice_idt) BEGIN
          SET @DOCALC = 0
        END
    END


    IF (@DOCALC = 1) BEGIN
        IF ( @iexercice_idt > -1 ) BEGIN
            SET @SEQ = @SEQ + '_' + cast(@iexercice_idt as varchar(9))
        END
        
        --propre � SQL SERVER, les g�n�rateurs n'existent pas et sont remplac� par des tables 
        --dont le nom commence par '__'
        SET @SEQ = '__' + @SEQ;

        IF NOT EXISTS(select * from dbo.sysobjects where id =
        object_id(N'[dbo].[' + @SEQ + ']') and OBJECTPROPERTY(id, N'IsUserTable') = 1) BEGIN
            SET @sql = N'CREATE TABLE dbo.[' + @SEQ + N'] ( [ID] [int] NOT NULL IDENTITY(1,1) NOT FOR REPLICATION, dtime datetime )'
            EXEC(@sql)
        END

        --recalculer la valeur du g�n�rateur
        IF ( NOT( (@ID_FIELD = '') OR (@TBL = '') ) ) BEGIN
            SET @CNT = 0;
            SET @sql = '';

            IF ( @iexercice_idt > -1 ) BEGIN
                SET @sql = N'SELECT MAX([' + @ID_FIELD + N']) FROM [' + @TBL + N'] WHERE EXERCICE_IDT = ' + cast(@iexercice_idt as varchar(9))
            END ELSE BEGIN
                SET @sql = N'SELECT MAX([' + @ID_FIELD + N']) FROM [' + @TBL + N']'
            END
            
            IF (@sql <> '') BEGIN
                CREATE TABLE #TMP (id int);
                EXEC(N'INSERT INTO #tmp ' + @sql)
                SELECT @CNT=id+1 FROM #TMP;
                DROP TABLE #TMP;
                
                IF (@CNT is NULL) BEGIN        
                    SET @CNT = 0;
                END            
            END

            --changer la valeur du g�n�rateur
            DBCC CHECKIDENT(@SEQ, RESEED, @CNT);
        END
    END

    FETCH CURSOR1 INTO @SEQ, @exercice_idt, @TBL, @ID_FIELD
  END

  CLOSE CURSOR1;
  DEALLOCATE CURSOR1;
END
go


CREATE TRIGGER POSITIONS_BI0 ON dbo.positions
INSTEAD OF INSERT
AS 
BEGIN
    DELETE FROM p
    FROM POSITIONS p, inserted i
    WHERE p.LOGIN = i.LOGIN
    AND p.KEYFIELD = i.KEYFIELD
    AND p.SECTIONFIELD = i.SECTIONFIELD
    AND p.MANDAT_IDT = i.MANDAT_IDT; 

    INSERT INTO positions(LOGIN, KEYFIELD, SECTIONFIELD, VALUEFIELD, MANDAT_IDT)
    SELECT LOGIN, KEYFIELD, SECTIONFIELD, VALUEFIELD, MANDAT_IDT
    FROM inserted;
END
GO


ALTER PROCEDURE [dbo].[GETCOMPTESOLDE_]
    @exercice_idt integer,
    @cpt_de varchar(15),
    @cpt_a varchar(15),
    @dt_deb datetime,
    @dt_fin datetime,
    @plan_comptable varchar(15),
    @SLD_ZERO_HIDDEN SMALLINT,
    @EXERCICE_IDT_PREC1 INTEGER,
    @CLASSE_FROM          SMALLINT,
    @CLASSE_TO            SMALLINT,
    @WITH_GROUPED         SMALLINT = 0,
    @WITH_TITRE              SMALLINT = 1
AS
BEGIN
    SET NOCOUNT ON;

    DECLARE @TEMPTBL TABLE (
        pos integer,
        cpte_id varchar(15),
        intitule varchar(120),
        titre integer,
        code_monnaie varchar(3),
        classe varchar(1),
        reflechis varchar(15),
        cpt_groupement varchar(15),
        parent varchar(15),
        niveau smallint,
        hidden smallint,
        solde_initial numeric(19,4),
        solde_initial_me numeric(19,4),
        solde_ini_grp numeric(19,4),
        solde_ini_me_grp numeric(19,4),
        solde_ini_r numeric(19,4),
        solde_ini_me_r numeric(19,4),
        solde_db numeric(17,2),
        solde_cr numeric(17,2),
        solde_db_me numeric(17,2),
        solde_cr_me numeric(17,2),
        solde_db_grp numeric(17,2),
        solde_cr_grp numeric(17,2),
        solde_db_grp_me numeric(17,2),
        solde_cr_grp_me numeric(17,2),
        solde_db_r numeric(17,2),
        solde_cr_r numeric(17,2),
        solde_db_r_me numeric(17,2),
        solde_cr_r_me numeric(17,2),
        budget numeric(17, 2),
        SOLDE_FINAL NUMERIC(17, 2),
        SOLDE_FINAL_ME NUMERIC(17, 2),
        SOLDE_FINAL_PREC1 NUMERIC(17, 2),
        SOLDE_FINAL_ME_PREC1 NUMERIC(17, 2),
        BUDGET_PREC1 NUMERIC(17, 2))

    --!!! si modification, strictement identique � @TEMPTBL
    DECLARE @TEMPTBLPREC TABLE (
        pos integer,
        cpte_id varchar(15),
        intitule varchar(120),
        titre integer,
        code_monnaie varchar(3),
        classe varchar(1),
        reflechis varchar(15),
        cpt_groupement varchar(15),
        parent varchar(15),
        niveau smallint,
        hidden smallint,
        solde_initial numeric(19,4),
        solde_initial_me numeric(19,4),
        solde_ini_grp numeric(19,4),
        solde_ini_me_grp numeric(19,4),
        solde_ini_r numeric(19,4),
        solde_ini_me_r numeric(19,4),
        solde_db numeric(17,2),
        solde_cr numeric(17,2),
        solde_db_me numeric(17,2),
        solde_cr_me numeric(17,2),
        solde_db_grp numeric(17,2),
        solde_cr_grp numeric(17,2),
        solde_db_grp_me numeric(17,2),
        solde_cr_grp_me numeric(17,2),
        solde_db_r numeric(17,2),
        solde_cr_r numeric(17,2),
        solde_db_r_me numeric(17,2),
        solde_cr_r_me numeric(17,2),
        budget numeric(17, 2),
        SOLDE_FINAL NUMERIC(17, 2),
        SOLDE_FINAL_ME NUMERIC(17, 2),
        SOLDE_FINAL_PREC1 NUMERIC(17, 2),
        SOLDE_FINAL_ME_PREC1 NUMERIC(17, 2),
        BUDGET_PREC1 NUMERIC(17, 2))


    DECLARE
        @tmp_dt_deb datetime,
        @tmp_dt_fin datetime;


    --si les dates des �critures n'a pas �t� pass�e
    SELECT @tmp_dt_deb=DATE_DEBUT, @tmp_dt_fin=DATE_FIN
    FROM EXERCICE
    WHERE exercice_idt = @exercice_idt;

    IF (coalesce(@DT_DEB, CAST('18991230' as datetime)) = CAST('18991230' as datetime)) BEGIN SET @DT_DEB = @TMP_DT_DEB; END
    IF (coalesce(@DT_FIN, CAST('18991230' as datetime)) = CAST('18991230' as datetime)) BEGIN SET @DT_FIN = @TMP_DT_FIN; END


    INSERT INTO @TEMPTBL
    SELECT  p.pos, c.cpte_id, c.intitule, c.titre, c.code_monnaie, c.classe,
            c.reflechis, c.cpt_groupement, p.parent, p.niveau, p.hidden,
            coalesce(c.solde_initial, 0), coalesce(c.solde_initial_me, 0), 0, 0, 0, 0,
            coalesce(SUM(coalesce(e.debit, 0)), 0), coalesce(SUM(coalesce(e.CREDIT, 0)), 0),
            coalesce(SUM(coalesce(e.debit_me, 0)), 0), coalesce(SUM(coalesce(e.CREDIT_ME, 0)), 0),
            0, 0, 0, 0, 0, 0, 0, 0, c.budget, 0, 0, 0, 0, 0


    FROM comptes c
        
    LEFT JOIN PLAN_COMPTABLE P
    ON P.exercice_idt = c.exercice_idt
    AND P.compte = c.cpte_id
    AND P.pc_id = @plan_comptable
        
    LEFT JOIN ECRITURES e
    ON e.exercice_idt = c.exercice_idt
    AND e.cpte = c.cpte_id
    AND e.DATE_ECR BETWEEN @dt_deb AND @dt_fin
        
    WHERE c.exercice_idt = @exercice_idt
    AND c.cpte_id BETWEEN @CPT_DE AND @CPT_A
    AND ( (@WITH_TITRE=1) OR ((@WITH_TITRE=0) AND (c.TITRE = 0)) )
    AND c.classe BETWEEN @CLASSE_FROM AND @CLASSE_TO

    GROUP BY    p.pos, c.cpte_id, c.intitule, c.titre, c.code_monnaie, c.classe, c.budget,
                c.reflechis, c.cpt_groupement, c.solde_initial, c.solde_initial_me,
                p.parent, p.niveau, p.hidden
    ORDER BY p.pos, c.cpte_id


    --#####################   REFLECHIS
    UPDATE t
    SET t.solde_ini_r = coalesce(r.SOLDE_INITIAL, 0),
        t.solde_ini_me_r = coalesce(r.SOLDE_INITIAL_ME, 0),
        t.solde_db_r = coalesce(r.solde_db, 0),
        t.solde_cr_r = coalesce(r.solde_cr, 0),
        t.solde_db_r_me = coalesce(r.solde_db_me, 0),
        t.solde_cr_r_me = coalesce(r.solde_cr_me, 0)
    FROM @TEMPTBL t

    LEFT JOIN
    (
        SELECT reflechis, SUM(SOLDE_INITIAL) as SOLDE_INITIAL, SUM(SOLDE_INITIAL_ME) as SOLDE_INITIAL_ME,
        SUM(solde_db) as solde_db, SUM(solde_cr) as solde_cr, SUM(solde_db_me) as solde_db_me, SUM(solde_cr_me) as solde_cr_me
        FROM @TEMPTBL
        WHERE coalesce(reflechis, '') <> ''
        AND (   ( (classe in ('1', '3')) AND ((solde_initial + solde_db - solde_cr) < 0) )
             OR ( (classe in ('2', '4')) AND ((solde_initial + solde_db - solde_cr) > 0) ) )
        GROUP BY reflechis
    ) as r

    ON t.cpte_id = r.reflechis

    -- supprimer ensuite les comptes dont les montants sont r�fl�chis (sinon ils apparaitront � double)
    DELETE FROM @TEMPTBL
    WHERE coalesce(reflechis, '') <> ''
    AND (   ( (classe in ('1', '3')) AND ((solde_initial + solde_db - solde_cr) < 0) )
         OR ( (classe in ('2', '4')) AND ((solde_initial + solde_db - solde_cr) > 0) ) )

    --#####################   REGROUPE
    IF ((@plan_comptable = '') AND (@WITH_GROUPED=0)) BEGIN
        UPDATE t
        SET t.solde_ini_grp = coalesce(r.SOLDE_INITIAL, 0),
            t.solde_ini_me_grp = coalesce(r.SOLDE_INITIAL_ME, 0),
            t.solde_db_grp = coalesce(r.solde_db, 0),
            t.solde_cr_grp = coalesce(r.solde_cr, 0),
            t.solde_db_grp_me = coalesce(r.solde_db_me, 0),
            t.solde_cr_grp_me = coalesce(r.solde_cr_me, 0)
        FROM @TEMPTBL t

        LEFT JOIN 
        (
            SELECT cpt_groupement, SUM(SOLDE_INITIAL) as SOLDE_INITIAL, SUM(SOLDE_INITIAL_ME) as SOLDE_INITIAL_ME,
            SUM(solde_db) as solde_db, SUM(solde_cr) as solde_cr, SUM(solde_db_me) as solde_db_me, SUM(solde_cr_me) as solde_cr_me
            FROM @TEMPTBL
            WHERE coalesce(cpt_groupement, '') <> ''
            GROUP BY cpt_groupement
        ) as r

        ON r.cpt_groupement = t.cpte_id

        -- supprimer ensuite les comptes dont les montants sont regroup� (sinon ils apparaitront � double)
        DELETE FROM @TEMPTBL
        WHERE coalesce(cpt_groupement, '') <> ''
    END


    --ORDRE D'IMPRESSION PAR DEFAUT SI PAS RENSEIGNE
    IF (coalesce(@plan_comptable, '') = '') BEGIN
        UPDATE @TEMPTBL
        SET PARENT = 
        (
            SELECT TOP 1 CPTE_ID
            FROM comptes

            WHERE exercice_idt = @exercice_idt
            AND titre = 1
            AND len(cpte_id) < len(t.cpte_id)
            AND cpte_id < t.cpte_id COLLATE database_default
            AND classe = t.CLASSE
            ORDER BY cpte_id DESC
        ),
        NIVEAU = len(t.cpte_id)-1
        FROM @TEMPTBL t
    END


    --#####################   SOLDE FINAL
    UPDATE @TEMPTBL
    set SOLDE_FINAL = solde_initial + solde_db - solde_cr + solde_ini_r + solde_db_r - solde_cr_r + solde_ini_grp + solde_db_grp - solde_cr_grp,
    SOLDE_FINAL_ME = solde_initial_me + solde_db_me - solde_cr_me + solde_ini_me_r + solde_db_r_me - solde_cr_r_me + solde_ini_me_grp + solde_db_me - solde_cr_me;

    if (@EXERCICE_IDT_PREC1 > 0) begin
        INSERT INTO @TEMPTBLPREC(pos, cpte_id, intitule, titre, code_monnaie, classe, reflechis, cpt_groupement, parent, niveau, hidden, solde_initial, solde_initial_me, solde_ini_grp, solde_ini_me_grp, solde_ini_r,
                solde_ini_me_r, solde_db, solde_cr, solde_db_me, solde_cr_me, solde_db_grp, solde_cr_grp, solde_db_grp_me, solde_cr_grp_me, solde_db_r, solde_cr_r, solde_db_r_me, solde_cr_r_me,
                budget, SOLDE_FINAL, SOLDE_FINAL_ME, SOLDE_FINAL_PREC1, SOLDE_FINAL_ME_PREC1, BUDGET_PREC1)
        EXEC GETCOMPTESOLDE_ @EXERCICE_IDT_PREC1, @cpt_de, @cpt_a, null, null, @plan_comptable, 0, 0, null, null


        UPDATE @TEMPTBL
        SET SOLDE_FINAL_PREC1 = p.SOLDE_FINAL,
        SOLDE_FINAL_ME_PREC1 = p.SOLDE_FINAL_ME
        FROM @TEMPTBL t

        INNER JOIN @TEMPTBLPREC p
        ON p.cpte_id = t.cpte_id;
    end

    --#####################   REMOVE SOLDE ZERO (WITHOUT TITRE)
    if (@SLD_ZERO_HIDDEN = 1) begin
        DELETE FROM @TEMPTBL
        WHERE titre = 0
        AND SOLDE_FINAL = 0
        AND SOLDE_FINAL_ME = 0
        AND SOLDE_FINAL_PREC1 = 0
        AND SOLDE_FINAL_ME_PREC1 = 0;
    end

    SELECT * FROM @TEMPTBL;
END
go


ALTER FUNCTION ANALYTIQUE_GET_PERIODE_DATE (
    @MANDAT_IDT INT,
    @DATE_ECR DATETIME,
    @PERIODE INT
)                    
RETURNS @TEMPTBL TABLE 
(
    REAL_PERIODE_DATE DATETIME
)
AS
BEGIN
  DECLARE
    @ECR_REAL_PERIOD    int,
    @START_PERIOD_MONTH    int,
    @START_PERIOD_YEAR    int,
    @PERIOD_CYCLE_MONTH    int,
    @DIFF_AVANT            int,
    @DIFF_APRES            int,
    @REAL_PERIODE_DATE    DATETIME;

    SELECT @START_PERIOD_MONTH = START_PERIOD_MONTH, @START_PERIOD_YEAR = START_PERIOD_YEAR, @PERIOD_CYCLE_MONTH = PERIOD_CYCLE_MONTH
    FROM MANDAT              
    WHERE MANDAT_IDT = @MANDAT_IDT

    IF (@PERIOD_CYCLE_MONTH = 0) BEGIN
        INSERT @TEMPTBL SELECT NULL
        RETURN
    END

    --calculer la periode en rapport a la date de l'ecriture (celle qui est passee peut etre differente)
    SET @ECR_REAL_PERIOD = (YEAR(@DATE_ECR)-@START_PERIOD_YEAR)*12 + (MONTH(@DATE_ECR)-@START_PERIOD_MONTH)
    SET @ECR_REAL_PERIOD = (@ECR_REAL_PERIOD % @PERIOD_CYCLE_MONTH) +1
                     
    --date du premier jour du mois de l'ecritures passee 
    SET @REAL_PERIODE_DATE = DATEADD(DAY,DAY(@DATE_ECR)*-1+1,@DATE_ECR)
                                
    --prendre la periode la plus proche comme reference

    --d'abord calculer la difference avec la periode precedente
     SET @DIFF_AVANT = (@PERIODE - @ECR_REAL_PERIOD)*-1

      --si negatif, un cycle est depasse
     if (@DIFF_AVANT < 0) begin
        SET @DIFF_AVANT = (@PERIOD_CYCLE_MONTH + @DIFF_AVANT)
     end

      --calculer la difference avec la periode precedente
     SET @DIFF_APRES = (@PERIODE - @ECR_REAL_PERIOD)

      --si negatif, un cycle est depasse
     if (@DIFF_APRES < 0) begin
        SET @DIFF_APRES = (@PERIOD_CYCLE_MONTH + @DIFF_APRES)
     end

     --toujours prendre la difference la plus petite ou la periode precedente en cas d'egalite
     if (@DIFF_AVANT > @DIFF_APRES) begin
        SET @REAL_PERIODE_DATE = dateadd(month, @DIFF_APRES, @REAL_PERIODE_DATE);                    
     end else begin
        SET @REAL_PERIODE_DATE = dateadd(month, @DIFF_AVANT*-1, @REAL_PERIODE_DATE);
     end

    INSERT @TEMPTBL SELECT @REAL_PERIODE_DATE
    RETURN
END 
go